/*
 * HttpAuth
 *
 * Copyright (C) 2008 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _TPOOL_H_
#define _TPOOL_H_

typedef void (*tpool_routine) (void*);

/* returns -1 if pool creation failed, 0 if succeeded */
int tpool_init (int max_threads, int min_threads, int max_queued);

/* returns -1 if failed (ie busy, closing etc...), 0 if succeeded */
int tpool_add_work (tpool_routine routine, void *arg);

/* cleanup and close. Must only be called once. Specify |finish| to drain queue */
int tpool_destroy (int finish);

#endif /* _TPOOL_H_ */
